# Desc: Adaptation of Erratic file to a generic, circular robot
# Author: Joey Durham
# Date: August 2008

include "perfectlaser.inc"

define circlebot position
(
  # actual size
  size [0.5 0.5]

  # the center of rotation is offset from its center of area
  origin [0 0.0 0]

  # draw a nose on the robot so we can see which way it points
  gui_nose 1

  # estimated mass in KG
  mass 12.0 
	
  polygons 1
  polygon[0].points 16
  polygon[0].point[0] [ 0.225 0.000 ]
  polygon[0].point[1] [ 0.208 0.086 ]
  polygon[0].point[2] [ 0.159 0.159 ]
  polygon[0].point[3] [ 0.086 0.208 ]
  polygon[0].point[4] [ 0.000 0.225 ]
  polygon[0].point[5] [ -0.086 0.208 ]
  polygon[0].point[6] [ -0.159 0.159 ]
  polygon[0].point[7] [ -0.208 0.086 ]
  polygon[0].point[8] [ -0.225 0.000 ]
  polygon[0].point[9] [ -0.208 -0.086 ]
  polygon[0].point[10] [ -0.159 -0.159 ]
  polygon[0].point[11] [ -0.086 -0.208 ]
  polygon[0].point[12] [ -0.000 -0.225 ]
  polygon[0].point[13] [ 0.086 -0.208 ]
  polygon[0].point[14] [ 0.159 -0.159 ]
  polygon[0].point[15] [ 0.208 -0.086 ]

  # this polygon approximates the shape of erratic
  #polygons 1
  #polygon[0].points 8
  #polygon[0].point[0] [  0.19  0.11 ]
  #polygon[0].point[1] [  0.13  0.19 ]
  #polygon[0].point[2] [ -0.13  0.19 ]
  #polygon[0].point[3] [ -0.19  0.10 ]
  #polygon[0].point[4] [ -0.19 -0.10 ]
  #polygon[0].point[5] [ -0.13 -0.19 ]
  #polygon[0].point[6] [  0.13 -0.19 ]
  #polygon[0].point[7] [  0.19 -0.11 ]

  # differential steering model
  drive "diff"

  # uncomment this line if you want to model real Erratics with SICK
  # lasers, where the laser is taller than the robot
  # laser_return 0

) 

define circlebot_perfect circlebot
(
	perfectlaser( pose [0 0 0] laser_sample_skip 1 )
)
